const parser = require('./src/parser');
const rde = require('./src/raw-data-extractor');
const mg = require('./src/metrics-generator');

// takes an array of file paths as input and returns array of correponding raw data as output
const generateRawData = paths => parser(paths).then(res => rde(res, paths));

// takes an array of raw data as inupt and returns array of corresponding metrics
const generateMetrics = rawData => mg(rawData);

module.exports = {
  generateRawData,
  generateMetrics,
};
