const fs = require('fs');
const babylon = require('babylon');

// takes an array of file paths as input
// return array of corresponding ASTs as output or error if something went wrong
module.exports = paths =>
  new Promise((resolve, reject) => {
    if (!Array.isArray(paths)) reject(new Error('Expect an array of paths'));

    const asts = paths
      .map(e => fs.readFileSync(e, { encoding: 'utf8' }))
      .map(e => babylon.parse(e));

    resolve(asts);
  });
