/* eslint-disable no-unused-expressions */
/* eslint-disable no-console */

const { expect } = require('chai');
const path = require('path');
const parser = require('../src/parser');

describe('PARSER - used to parse source files to produce ASTs', () => {
  const pathFileA = path.join(__dirname, './test-source/basic-a.js');
  const pathFileB = path.join(__dirname, './test-source/basic-b.js');

  it('should return an error since the parameter is not an arrray', (done) => {
    parser(pathFileA)
      .then(() => expect(null).to.exist)
      .catch((err) => {
        expect(err.message).to.equal('Expect an array of paths');
        done();
      });
  });

  it('should parse a single file and return the corresponding AST', (done) => {
    parser([pathFileA])
      .then((res) => {
        expect(res.length).to.equal(1);
        expect(res[0].type).to.equal('File');
        done();
      })
      .catch(err => console.error(err));
  });

  it('should parse several files and return the corresponding ASTs', (done) => {
    parser([pathFileA, pathFileB])
      .then((res) => {
        expect(res.length).to.equal(2);
        expect(res[0].type).to.equal('File');
        done();
      })
      .catch(err => console.error(err));
  });
});
