/* eslint-disable no-unused-expressions */
/* eslint-disable no-console */

const { expect } = require('chai');
const path = require('path');
const index = require('../index');

const expectedResultFunctionsFileA = [
  {
    posLine: 1,
    name: 'add',
    type: 'FunctionDeclaration',
    numLines: 3,
    numChara: 46,
    params: [
      {
        name: 'a',
        defaultValue: true,
      },
      {
        name: 'b',
        defaultValue: true,
      },
    ],
  },
  {
    posLine: 5,
    name: 'multiply',
    type: 'ArrowFunctionExpression',
    numLines: 1,
    numChara: 15,
    params: [
      {
        name: 'a',
        defaultValue: false,
      },
      {
        name: 'b',
        defaultValue: false,
      },
    ],
  },
];

describe('RAW-DATA-EXTRACTOR - extract data we are looking for from ASTs', () => {
  const pathFileA = path.join(__dirname, './test-source/basic-a.js');
  // const pathFileB = path.join(__dirname, './test-source/basic-b.js');

  // it('should return an error since the parameter is not an arrray', (done) => {
  // parser(pathFileA)
  // .then(() => expect(null).to.exist)
  // .catch((err) => {
  // expect(err.message).to.equal('Expect an array of paths');
  // done();
  // });
  // });

  it('should parse a single file and return the corresponding AST', (done) => {
    index
      .generateRawData([pathFileA])
      .then((res) => {
        expect(res[0].functions).to.deep.equal(expectedResultFunctionsFileA);
        expect(res[0].file.numLines).to.equal(8);
        expect(res[0].file.numChara).to.equal(133);
        expect(res[0].file.filePath).to.be.a('string');
        done();
      })
      .catch(err => console.error(err));
  });
});
